MODULE Blinker;
(* =========================================================================  
   Example Oberon ARM Cortex-M3 Program  
 
   Description:
     Led connected to P0.7 blinking approx. once per second

   Target:
     NXP LPC1343
     
   Tested on: 
     Embedded Artists QuickStart LPC1343 and LPCXpresso LPC1343
   
   References: 
     NXP UM10375 LPC1311/13/42/43 User manual
     Oberon for LPC1000 Microcontrollers
   
   (c) 2012 CFB Software   
   http://www.astrobe.com  
   
   ========================================================================= *)

IMPORT Main, SYSTEM;

PROCEDURE Delay(n: INTEGER);
VAR
  i: INTEGER;
BEGIN
  FOR i := 0 TO n * 1024 DO END 
END Delay;

PROCEDURE Run();
CONST
  (* led connected to pin P0.7 *)
  ledBit = {7};
  GPIO0DIR = 050008000H;
  GPIODATA = 050003FFCH;
VAR
  direction: SET;
  i: INTEGER;
BEGIN
  
  (* Set led pin as output by setting the direction bit *)
  SYSTEM.GET(GPIO0DIR, direction);
  SYSTEM.PUT(GPIO0DIR, direction + ledBit);
  
  WHILE TRUE DO
    SYSTEM.PUT(GPIODATA, ledBit);
    Delay(500);
    SYSTEM.PUT(GPIODATA, 0);
    Delay(500)
  END
END Run;

BEGIN
  Run()
END Blinker.
